package cn.com.infosec.asn1.isismtt.x509;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERBoolean;
import cn.com.infosec.asn1.DERGeneralizedTime;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERPrintableString;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;

public class DeclarationOfMajority extends ASN1Encodable implements ASN1Choice {
   public static final int notYoungerThan = 0;
   public static final int fullAgeAtCountry = 1;
   public static final int dateOfBirth = 2;
   private ASN1TaggedObject declaration;

   public DeclarationOfMajority(int notYoungerThan) {
      DeclarationOfMajority var10000 = this;
      super();
      DERTaggedObject var3;
      DERTaggedObject var10001 = var3 = new DERTaggedObject;
      DERInteger var2;
      var2 = new DERInteger.<init>(notYoungerThan);
      var10001.<init>(false, 0, var2);
      var10000.declaration = var3;
   }

   public DeclarationOfMajority(boolean fullAge, String country) {
      if (country.length() <= 2) {
         DeclarationOfMajority var10000;
         DERSequence fullAge1;
         if (fullAge) {
            var10000 = this;
            DERTaggedObject var4;
            DERTaggedObject var10001 = var4 = new DERTaggedObject;
            DERSequence var10002 = fullAge1 = new DERSequence;
            DERPrintableString var3;
            var3 = new DERPrintableString.<init>(country, true);
            var10002.<init>(var3);
            var10001.<init>(false, 1, fullAge1);
            var10000.declaration = var4;
         } else {
            var10000 = this;
            ASN1EncodableVector var5;
            ASN1EncodableVector var7 = var5 = new ASN1EncodableVector;
            var7.<init>();
            var7.add(DERBoolean.FALSE);
            var7.add(new DERPrintableString(country, true));
            fullAge1 = new DERSequence.<init>(var5);
            var10000.declaration = new DERTaggedObject(false, 1, fullAge1);
         }

      } else {
         throw new IllegalArgumentException("country can only be 2 characters");
      }
   }

   public DeclarationOfMajority(DERGeneralizedTime dateOfBirth) {
      DeclarationOfMajority var10000 = this;
      super();
      DERTaggedObject var2;
      var2 = new DERTaggedObject.<init>(false, 2, dateOfBirth);
      var10000.declaration = var2;
   }

   public static DeclarationOfMajority getInstance(Object obj) {
      if (obj != null && !(obj instanceof DeclarationOfMajority)) {
         if (obj instanceof ASN1TaggedObject) {
            return new DeclarationOfMajority((ASN1TaggedObject)obj);
         } else {
            throw new IllegalArgumentException("illegal object in getInstance: " + obj.getClass().getName());
         }
      } else {
         return (DeclarationOfMajority)obj;
      }
   }

   private DeclarationOfMajority(ASN1TaggedObject o) {
      if (o.getTagNo() <= 2) {
         this.declaration = o;
      } else {
         throw new IllegalArgumentException("Bad tag number: " + o.getTagNo());
      }
   }

   public DERObject toASN1Object() {
      return this.declaration;
   }

   public int getType() {
      return this.declaration.getTagNo();
   }

   public int notYoungerThan() {
      return this.declaration.getTagNo() != 0 ? -1 : DERInteger.getInstance(this.declaration, false).getValue().intValue();
   }

   public ASN1Sequence fullAgeAtCountry() {
      return this.declaration.getTagNo() != 1 ? null : ASN1Sequence.getInstance(this.declaration, false);
   }

   public DERGeneralizedTime getDateOfBirth() {
      return this.declaration.getTagNo() != 2 ? null : DERGeneralizedTime.getInstance(this.declaration, false);
   }
}
